header
lorom

; Currently this patch should only function correctly in:
; - Layer 3 tides
; - Layer 2 levels with game mode 02
; - Normal levels that do not contain interactive layer 2 or 3

;----------;
;   ASM    ;
;----------;

org $00A050
STA $704800,x ; Layer 3 water tiles (for the tide) are now written in SRAM, just like Layer 2.
              ; This means that Layer 3 tides are now compatible with normal levels longer than $10 screens...
              ; ...but these tides are still incompatible with interactive Layer 2.

org $00BF09
JML Main      ; Routine handling Map16 blocks that change to another block (such as coins or ? blocks).

org $00BF2A
JML Utrecht5  ; Just a fix to a former bug I encountered in relation to the JML above. Not very significant to check out.

org $00F500
CPX #$20      ; Layer 2 level interaction now stops at screen $20 rather than screen $10.

org $00F50D
JML DenHaag   ; Layer 2 interaction routine (Mario)

org $019504
JML Utrecht   ; Layer 2 interaction routine (most sprites)

org $0292FD
JML Utrecht2  ; Layer 2 interaction routine (bounce block sprites)

org $0295F0
JML Utrecht3  ; Layer 2 interaction routine (cape)

org $02A6BE
JML Utrecht4  ; Layer 2 interaction routine (fireball)

org $02BA75
JML Utrecht6  ; Layer 2 interaction routine (Yoshi)

org $02D190
JML Utrecht7  ; Layer 2 interaction routine (Yoshi)

org $058334
JSL Wait      ; Clear level, low page.
    
org $0583A6
JSL Wait2     ; Clear level, high page.

org $058676
JML Main2     ; Loads a pointer for Layer 2 level load data.

org $058BA9
JML WaitWaitWait ; Loads another pointer for Layer 2 level load data.

;----------;

org $1C8000 ; FREESPACE!!
reset bytes

db "STAR" ; Random RATs.
dw End-Main-$01
dw End-Main-$01^$FFFF

Main:
CPY #$0004
BEQ Irregular ; Only handle code if game mode is game mode 02.

Regular:
LDA [$65],y ; Regular Map16 pointers.
STA $04
JML $00BF0D

Irregular:
LDA $1933 ; Only handle it if the layer being handled is layer 2 (or 3).
BEQ Regular
LDA.b #L2Tbl ; Load new pointer.
STA $04
LDA.b #L2Tbl/256
STA $05
LDA.b #L2Tbl/65536
STA $06
JML $00BF14

WaitWaitWait:
LDA $1925 ; Only handle code if game mode is game mode 02.
CMP #$02
BEQ OhOhOh
LDA.l $00BDE8,x ; This is the regular pointer.
JML $058BAD

OhOhOh:
LDA.b #L2Tbl ; These are the new pointers for both low and high Map16 bytes.
STA $0A
LDA.b #L2Tbl/256
STA $0B
LDA.b #L2Tbl/65536
STA $0C
LDA.b #L2HiTbl
STA $0D
LDA.b #L2HiTbl/256
STA $0E
LDA.b #L2HiTbl/65536
JML $058BC5

; Layer 2 tables, per screen (screens 00-1F).
; They are now in SRAM banks $70 and $71.
L2Tbl:
dl $704800,$7049B0,$704B60,$704D10,$704EC0
dl $705070,$705220,$7053D0,$705580,$705730
dl $7058E0,$705A90,$705C40,$705DF0,$705FA0
dl $706150

dl $706300,$7064B0,$706660,$706810,$7069C0
dl $706B70,$706D20,$706ED0,$707080,$707230
dl $7073E0,$707590,$707740,$7078F0,$707AA0
dl $707C50

L2HiTbl:
dl $714800,$7149B0,$714B60,$714D10,$714EC0
dl $715070,$715220,$7153D0,$715580,$715730
dl $7158E0,$715A90,$715C40,$715DF0,$715FA0
dl $716150

dl $716300,$7164B0,$716660,$716810,$7169C0
dl $716B70,$716D20,$716ED0,$717080,$717230
dl $7173E0,$717590,$717740,$7178F0,$717AA0
dl $717C50

Main2:
CPY #$04 ; Handle only if game mode 02.
BEQ Irregular2

Regular2:
LDA [$03],y ; Normal pointer.
STA $00
JML $05867A

Irregular2:
LDA $1933 ; Handle only if layer 2 is handled
BEQ Regular2
LDA.b #L2Tbl ; Load new Layer 2 pointers.
STA $00
LDA.b #L2Tbl/256
STA $01
LDA.b #L2Tbl/65536
STA $02
LDA.b #L2HiTbl
STA $0D
LDA.b #L2HiTbl/256
STA $0E
LDA.b #L2HiTbl/65536
STA $0F
JML $05868D

Wait:
STA $7EFE00,x ; Hijack in the level clear routine...
STA $704800,X ; ... to clear Layer 2 tables at the start...
STA $704A00,X ; ... of every room as well.
STA $704C00,X ; This is the low byte table (#$25)...
STA $704E00,X ; ... the code starting at "Wait2:" handles the high byte (#$00).
STA $705000,X           
STA $705200,X           
STA $705400,X           
STA $705600,X           
STA $705800,X           
STA $705A00,X           
STA $705C00,X           
STA $705E00,X           
STA $706000,X           
STA $706200,X           
STA $706400,X           
STA $706600,X           
STA $706800,X           
STA $706A00,X           
STA $706C00,X           
STA $706E00,X           
STA $707000,X           
STA $707200,X           
STA $707400,X           
STA $707600,X           
STA $707800,X           
STA $707A00,X           
STA $707C00,X         
STA $707E00,X       
RTL

Wait2:
STA $7FFE00,x
STA $714800,X           
STA $714A00,X           
STA $714C00,X           
STA $714E00,X           
STA $715000,X           
STA $715200,X           
STA $715400,X           
STA $715600,X           
STA $715800,X           
STA $715A00,X           
STA $715C00,X           
STA $715E00,X           
STA $716000,X           
STA $716200,X           
STA $716400,X           
STA $716600,X           
STA $716800,X           
STA $716A00,X           
STA $716C00,X           
STA $716E00,X           
STA $717000,X           
STA $717200,X           
STA $717400,X           
STA $717600,X           
STA $717800,X           
STA $717A00,X           
STA $717C00,X           
STA $717E00,X     
RTL

DenHaag:
ADC $00BA60,x ; Pointers for Layer 2 pages.
STA $00
LDA $99
ADC.l Layer2Hi,x ; A new table is used here.
STA $01
LDA #$70 ; High byte.
JML $00F4D1

Layer2Hi:
db $48,$49,$4B,$4D,$4E,$50,$52,$53
db $55,$57,$58,$5A,$5C,$5D,$5F,$61
db $63,$64,$66,$68,$69,$6B,$6D,$6E
db $70,$72,$73,$75,$77,$78,$7A,$7C

; The same principe goes on for all the routines below...
; ...except they're used for other types of course, such as sprites or cape interaction.
Utrecht:
LDY $185E
BEQ LAYER1HE
LDA.l $00BA60,x
CLC
ADC $00
STA $05
LDA.l Layer2Hi,x
ADC $0D
STA $06
LDA #$70
JML $019525

LAYER1HE:
JML $01950D

Utrecht2:
LDY $0F
BEQ LAYER1HE2
LDA.l $00BA60,x
CLC
ADC $00
STA $05
LDA.l Layer2Hi,x
ADC $02
STA $06
LDA #$70
JML $02931C

LAYER1HE2:
JML $029305

Utrecht3:
LDY $0F
BEQ LAYER1HE3
LDA.l $00BA60,x
CLC
ADC $00
STA $05
LDA.l Layer2Hi,x
ADC $02
STA $06
LDA #$70
JML $02960F

LAYER1HE3:
JML $0295F8

Utrecht4:
LDY $0F
BEQ LAYER1HE4
LDA.l $00BA60,x
CLC
ADC $00
STA $05
LDA.l Layer2Hi,x
ADC $02
STA $06
LDA #$70
JML $02A6DD

LAYER1HE4:
JML $02A6C6

Utrecht6:
LDY $0F
BEQ LAYER1HE6
LDA.l $00BA60,x
CLC
ADC $04
STA $05
LDA.l Layer2Hi,x
ADC $0D
STA $06
LDX $15E9
LDA #$70
JML $02BA97

LAYER1HE6:
JML $02BA7D

Utrecht7:
LDY $0F
BEQ LAYER1HE7
LDA.l $00BA60,x
CLC
ADC $00
STA $05
LDA.l Layer2Hi,x
ADC $02
STA $06
LDA #$70
JML $02D1AF

LAYER1HE7:
JML $02D198

; Just a bugfix to some bug I encountered earlier with coins not disappearing.
Utrecht5:
LDA $1933 ; #$7E is high byte of pointer if it's about Layer 1.
BEQ Normal
LDA #$70 ; Otherwise, #$70.

Abnormal:
STA $6D
JML $00BF2E

Normal:
LDA #$7E
BRA Abnormal

End:

print bytes
print "This is the amount of freespace you needed."

;------------;
; 128kb SRAM ;
;------------;

org $00FFD8
db $07 ; Should be self-explanatory.